<?

//////////////////////////////                ////////////////////////////////////

/**
 *                                                              
 *                                                     
 *                                                                                                         
 *                                                                                
 * 
 *                                                                           
 *                                                                             
 *
 *                                         
 *
 *                                                                                                                                                   
 * 
 **/
function i18n($meta, $module = 0) {
global $LANGUAGE;

if ( strpos($meta, "'") !== false )
warning( 7, "BUG: Don't use ' in i18n meta ($meta)" );
$params = array();

//                         
 if (func_num_args() > 2) {
$arg = func_get_arg(2);
if (is_array($arg)) {
$params = $arg;
} else {
//                           
 for ($i = 0; $i < func_num_args() - 2; $i++) {
$params[$i] = func_get_arg($i + 2);
}
}
}

return i18n_lang($meta, $module, $LANGUAGE, $params);
}

/**
 *                                                            
 *
 *                                                               
 *                               
 *                                   
 *          
 *                                     
 *                                                        
 *                                                     
 *                                                                       
 *                                                                
 *                               
 **/
function i18n_lang($meta, $module = 0, $language = 0, $params = array(), $useUserDic = true) {
global $DEBUG, $DIC_SOURCE;

//                                   
 if ($val = i18n_fetch($meta, $language, $module, $useUserDic)) {
$text = $val["text"];
if ($DEBUG["i18n"] && $DEBUG["echo"]) $text .= "(i:".$val["id"].")";
} else {
//                                    
 $text = $meta;

if ($DEBUG["i18n"] && $DEBUG["echo"]) $text .= "(m:".$meta.")";
if ($DEBUG["i18n_create"] && $DEBUG["echo"] && $DIC_SOURCE == "db" && !i18n_exists($meta)) {
//                                     
 echo "Creating i18n with meta '$meta'<br />";
$id = i18n_create($meta);
}
}

//               
 if (is_array($params) && count($params) > 0) {
reset($params);
while (list($key,$val) = each($params)) {
$text = str_replace("{".$key."}",$val, $text);
$i++;
}
}

return $text;
}

/**
 *                                               
 * 
 *                                              
 *                                                         
 **/
function i18n_clear_cache($meta = "") {
global $I18N_FETCH_CACHE;
$I18N_FETCH_CACHE = array();
}

////////////////////////////////                               ///////////////////////////

/**
 *                                                                             
 *                
 *                                                                    
 **/
function i18n_fetch($meta, $language, $module, $userdic) {
global $DEBUG, $METALANGUAGE_ID, $I18N_DIC, $I18N_FETCH_CACHE, $DIC_SOURCE, $FEATURE;

$lmeta = strtolower($meta);

//                                                           
 $key = ($userdic)?"1":"0";
$key .= ":".$language.":".$lmeta;
if (isset($I18N_FETCH_CACHE[$key][$module])) {
//                      
 return $I18N_FETCH_CACHE[$key][$module];
} else if ($module > 0 && isset($I18N_FETCH_CACHE[$key][0])) {
//                                             
 return $I18N_FETCH_CACHE[$key][0];
}

//                       
 $entry = array();
$gotuser = false;
$gotdic = false;
if ($userdic) {
$sql = "SELECT dic.value, dic.output_id FROM dicuser AS dic, dicuser AS mdic WHERE dic.output_id = mdic.output_id AND dic.language_id = ".sqlf_tl_num($language)." 
		         AND mdic.language_id = ".sqlf_tl_num($METALANGUAGE_ID)." AND mdic.value = \"".sqlslashes($lmeta)."\"";
$rs = query($sql,1);//            
 $gotuser = ($rs["num"] > 0);

if ($gotuser) {
$entry["text"] = $rs["arr"][0]["value"];
$entry["id"] = $rs["arr"][0]["output_id"];
$entry["user"] = true;
}
}

if (!$gotuser) {
if ($DIC_SOURCE == "db") {
//                    
 $db = getDicDBHandle();

$sql = "SELECT dic.value, dic.output_id FROM dic, dic AS mdic WHERE dic.output_id = mdic.output_id AND dic.language_id = ".sqlf_tl_num($language)." 
			         AND mdic.language_id = ".sqlf_tl_num($METALANGUAGE_ID)." AND mdic.value = \"".sqlslashes($lmeta)."\"";
$rs = query($sql,1,0,$db);//            
 $gotdic = ($rs["num"] > 0);

if ($gotdic) {
$entry["text"] = $rs["arr"][0]["value"];
$entry["id"] = $rs["arr"][0]["output_id"];
$entry["user"] = false;
}
} else {
//                              
 $dic = load_dictionary($language, false);
$metadic = load_dictionary($METALANGUAGE_ID, false);

if (($id = $metadic[$lmeta]) && ($text = $dic[(int) $metadic[$lmeta]])) {
$gotdic = true;
$entry["text"] = $text;
$entry["id"] = $id;
$entry["user"] = false;
}
}
}

if ($gotuser || $gotdic) {
///                     
 //                                                                             
 if (count($I18N_FETCH_CACHE) > 200) {
///                            
 array_shift($I18N_FETCH_CACHE);
}
$I18N_FETCH_CACHE[$key][0] = $entry;
return $entry;
} else {
$I18N_FETCH_CACHE[$key][0] = false;
return false;
}
}

////////////////////////////                            ////////////////////////////////

/**
 *                                                                               /       
 *                            
 *                        
 *                                                   
 **/
function i18n_exists($meta,$id = 0, $userdic = false) {
global $METALANGUAGE_ID, $DB;

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";

$sql = "SELECT output_id FROM $dic WHERE value = \"".sqlslashes($meta)."\" AND language_id = ".sqlf_tl_num($METALANGUAGE_ID);
if ($id) $sql .= " AND output_id != \"".sqlf_escaped($id)."\"";
$rs = query($sql,1,0,$db);//            
 
if ($rs["num"]) return true;
else return false;
}

/**
 *                                                            
 *                             
 **/
function i18n_get($meta, $userdic = false) {
global $METALANGUAGE_ID, $DB;

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";

$sql = "SELECT output_id FROM $dic WHERE value = \"".sqlslashes($meta)."\" AND language_id = ".sqlf_tl_num($METALANGUAGE_ID);
$rs = query($sql,1,0,$db);//            

if ($rs["num"]) return $rs["arr"][0]["output_id"];
else return false;
}

/**
 *                                                                  
 *                                                                                        
 **/
function i18n_set($text, $output_id, $language_id = 0, $userdic = false) {
global $METALANGUAGE_ID, $LANGUAGE, $DB;

if (!$language_id) $language_id = $LANGUAGE;

if (!isset($text) || $text === "") return i18n_unset($output_id, $language_id, $userdic);

if ($language_id == $METALANGUAGE_ID) {
//                                 
 if (i18n_exists($text, $output_id, $userdic)) {
//                                              
 return 1;
}
}

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";

$sql = "SELECT value FROM $dic WHERE output_id = ".sqlf_tl_num($output_id)." AND language_id = ".sqlf_tl_num($language_id);
$rs = query($sql, $db);//            

if ($rs["num"] == 0) {
$sql = "INSERT INTO $dic (output_id, language_id, value) VALUES (".sqlf_tl_num($output_id).", ".sqlf_tl_num($language_id).", \"".sqlslashes($text)."\")";
query($sql, $db);//            
 } else if ($rs["arr"][0]["value"] != $text) {
$sql = "UPDATE $dic SET value = \"".sqlslashes($text)."\" WHERE output_id = ".sqlf_tl_num($output_id)." AND language_id = ".sqlf_tl_num($language_id);
query($sql, $db);//            
 }

return 0;
}

/**
 *                                          
 *                                
 *                                                                    
 **/
function i18n_unset($output_id, $language_id = 0, $userdic = false) {
global $METALANGUAGE_ID, $LANGUAGE, $DB;

if (!$language_id) $language_id = $LANGUAGE;

if ($language_id == $METALANGUAGE_ID) {
//                                
 return 1;
}

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";

$sql = "DELETE FROM $dic WHERE output_id = ".sqlf_tl_num($output_id)." AND language_id = ".sqlf_tl_num($language_id);
query($sql);//            
 
return 0;
}

/**
 *                                                                          
 *                                                    
 **/
function i18n_create($meta, $info = 99, $enabled = false, $userdic = false) {
global $METALANGUAGE_ID, $DB;

if (i18n_exists($meta, 0, $userdic)) {
//                                       
 return false;
}

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";

//                    
 if ($userdic) {
$sql = "INSERT INTO outputuser (info) VALUES (".sqlf_tl_num($info).")";
} else {
$sql = "INSERT INTO output (info, enabled) VALUES (".sqlf_tl_num($info).", ".(($enabled)?1:0).")";
}
$rs = query($sql, $db);//            
 
$output_id = $rs["iid"];

//                  
 $sql = "INSERT INTO $dic (output_id, language_id, value) VALUES (".sqlf_tl_num($output_id).", ".sqlf_tl_num($METALANGUAGE_ID).", \"".sqlslashes($meta)."\")";
query($sql, $db);//            

return $output_id;
}

function i18n_update($output_id, $info = 99, $enabled = false, $userdic = false) {
//                       
}

/**
 *                                                     
 **/
function i18n_delete($output_id, $userdic = false) {
global $DB;

$db = ($user)?$DB:getDicDBHandle();
$dic = ($userdic)?"dicuser":"dic";
$output = ($userdic)?"outputuser":"output";

$sql = "DELETE FROM $dic WHERE output_id = ".sqlf_tl_num($output_id);
query($sql, $db);//            
 $sql = "DELETE FROM $output WHERE id = ".sqlf_tl_num($output_id);
query($sql, $db);//            

return 0;
}

//////////////////////////////                      /////////////////////////////////

/**
 *                                                        
 *                
 **/
function i18n_load(&$dic, $language, $userdic = false) {
global $METALANGUAGE_ID;

$meta = load_dictionary($METALANGUAGE_ID, $userdic);

$lang = load_dictionary($language, $userdic);

reset($meta);
while (list($key,$val) = each($meta)) {
if (!$val) $val = "id: $key";
$dic[$val]["text"] = $lang[$key];
$dic[$val]["id"] = $key;
$dic[$val]["user"] = $userdic;
}
}

/**
 *                                                                                                                
 **/
function i18n_init($language, $userdic = 0, $force = false) {
global $METALANGUAGE_ID, $I18N_LANG_CACHE;

//                                                                                         
 
//                                                                    
 
if ($I18N_LANG_CACHE[$language][$userdic] && !$force) {
return unserialize($I18N_LANG_CACHE[$language][$userdic]);
}
$dic = array();

if ($userdic != 1) {
i18n_load($dic,$language,false);
}

//                          
 if ($userdic > 0) {
i18n_load($dic,$language,true);
}

$I18N_LANG_CACHE[$language][$userdic] = serialize($dic);

return $dic;
}

function i18n_register() {

mysession_var_reg("I18N_LANG_CACHE");
mysession_var_reg("I18N_FETCH_CACHE");

//                                              

}

$EXEC_FUNC[] = "i18n_register";

?>
