<?

define("DCP_TIME",1);
define("DCP_DATE",2);
define("DCP_DATETIME",3);

class DateComponent extends ColumnComponent {

var $time;
var $m_dateComponentName = "d";
var $m_timeComponentName = "t";

function DateComponent( $label=NULL, $timestamp = false, $mode = DCP_DATE, $allowEmpty = true) {
global $TIME;
parent::ColumnComponent($label);
$this->d_values["allowEmpty"] = $allowEmpty;
$this->d_values["editable"] = true;
$this->time = new TimeObject( $timestamp !== false?$timestamp:$TIME );
$idate = new TextComponent( NULL, $this->d_values["editable"], "", REG_DATE_ALT, 10 );
$idate->setOnKeyDown( "changedate", "changeDate(this, event);");
$idate->setMaxSize(7);
$itime = new TextComponent( NULL, $this->d_values["editable"], "", REG_TIME_ALT, 7 );
$itime->setMaxSize(5);
$this->setComponent( $this->m_dateComponentName, $idate );
$this->setComponent( $this->m_timeComponentName, $itime );
$this->setMode( $mode );
$this->_updateTextFields();

}

function setTimestamp($time) {
$this->time->setTimestamp($time);
$this->_updateTextFields();
}

function getTimestamp() {
return $this->time->getTimestamp();
}

function setTimeObject(&$time) {
$this->time =& $time;
$this->_updateTextFields();
}

function &getTimeObject() {
return $this->time;
}

function &getResultObject() {
return $this->time;
}

function setObject(&$obj) {
if (is_a($obj, "timeobject")) {
$this->setTimeObject($obj);
}
}

function setShowTime($val) {
$this->d_values["showTime"] = $val;
$c =& $this->getComponent( $this->m_timeComponentName );
$c->setHidden( !$val );
}

function setShowDate($val) {
$this->d_values["showDate"] = $val;
$c =& $this->getComponent( $this->m_dateComponentName );
$c->setHidden( !$val );
}

/**
  *                                                                 
  **/
function setAllowEmpty($val) {
$this->d_values["allowEmpty"] = $val;
}

function setEditable($val) {
$this->d_values["editable"] = $val;
}

function setMode($mode) {
$this->setShowTime( ($mode & 1)?TRUE:FALSE );
$this->setShowDate( ($mode & 2)?TRUE:FALSE );
}

function reset() {
global $TIME;
$this->time->setTimestamp($this->d_values["allowEmpty"]?0:$TIME);
$this->_updateTextFields();
}

function getSerializeKey() {
$rs["parent"] = parent::getSerializeKey(TRUE);
$rs["time"] = node_serialize($this->time);
return $rs;
}

function initFromSerializeKey( $key ) {
parent::initFromSerializeKey( $key["parent"] );
$this->time = &node_unserialize( $key["time"] );
}

function onLoadFinished() {
parent::onLoadFinished();
global $TIME;
$cDate = &$this->getComponent($this->m_dateComponentName);
$cTime = &$this->getComponent($this->m_timeComponentName);
if (!$this->d_values["showDate"]) $date = "";
else $date = $cDate->getText();
if (!$this->d_values["showTime"]) $time = "";
else $time = $cTime->getText();

if ( $date == "" && $time == "" ) {
$ts = ($this->d_values["allowEmpty"])? 0 : $TIME;
} else {
$dts = date2ts($date);
$tts = time2ts($time);

$isError = FALSE;
if (is_string($dts)) {
$cDate->addError( new NodeException( $dts ) );
$isError = TRUE;
}
if (is_string($tts)) {
$cTime->addError( new NodeException( $tts ) );
$isError = TRUE;
}

if (!$isError) {
$ts = merge_date_time( $dts, $tts );
}
}

$this->time->setTimestamp($ts);
if (!$isError) {
$this->_updateTextFields();
}
}

function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
$main =& GUIFactory::getMainGUI();
$main->includeJS( "tools" );
return parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key );
}

function toString() {
return $this->time->toString();
}

function isFinished() {
return true;
}

function _updateTextFields() {
$ts = $this->time->getTimestamp();
$cDate = &$this->getComponent($this->m_dateComponentName);
$cTime = &$this->getComponent($this->m_timeComponentName);
if ($ts > 0) {
$cDate->setText( date("d.m.Y",$ts) );
$cTime->setText( date("H:i",$ts) );
} else {
$cDate->setText( "" );
$cTime->setText( "" );
}
}

}

class CalendarComponent extends SelectableFormComponent {

var $d_time;
var $d_selected;
var $d_finished;

function CalendarComponent($obj = NULL, $label = NULL) {
parent::SelectableFormComponent();
$this->setLabel($label);
if ($obj === NULL) {
$this->d_time = new TimeObject();
$this->reset();
} else {
$this->setObject($obj);
}
}

function reset() {
global $TIME;
$this->d_time->setTimestamp($TIME);
$this->jumpToDate($TIME);
$this->d_finished = false;
}

function jumpToDate($timestamp) {	
$this->d_selected = $timestamp;
}

function setTimeObject(&$obj) {
if (is_a($obj, "timeobject")) {
$this->d_time =& $obj;
$this->jumpToDate($obj->getTimestamp());
$this->d_finished = true;
}
}

function setObject(&$obj) {
$this->setTimeObject($obj);
}

function &getTimeObject() {
return $this->d_time;
}

function &getResultObject() {
return $this->d_time;
}

function setTimestamp($time) {
$this->d_time->setTimestamp($time);
$this->jumpToDate($time);
$this->d_finished = true;
}

function getTimestamp() {
$this->d_time->getTimestamp();
}

function getSerializeKey() {
$rs["parent"] = parent::getSerializeKey();
$rs["time"] = node_serialize($this->d_time);
$rs["select"] = $this->d_selected;
$rs["finished"] = $this->d_finished;
return $rs;
}

function initFromSerializeKey($key) {
parent::initFromSerializeKey($key["parent"]);
$this->d_time = &node_unserialize($key["time"]);
$this->d_selected = $key["select"];
$this->d_finished = $key["finished"];
}

function isFinished() {
return $this->d_finished;
}

function resolveAction(&$form, &$action) {
if ($action->getName() == "ts") {
$this->d_selected = $action->getParam();
}
if ($action->getName() == "select") {
$this->d_selected = $action->getParam();
$this->setTimestamp($this->d_selected);
$this->selectionFinished();
}
}

function getHTML(&$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
global $TIME;

$hour = date("H",$this->d_selected);
$min = date("i", $this->d_selected);
$sec = date("s", $this->d_selected);

$year = date("Y", $this->d_selected);
$month = date("m", $this->d_selected);
$day = date("d", $this->d_selected);

$today = mktime($hour, $min, $sec, date("m"), date("d"), date("Y"));
$selected = $this->d_selected;
$nextYear = mktime($hour, $min, $sec, $month, $day, $year + 1);
$lastYear = mktime($hour, $min, $sec, $month, $day, $year - 1);
$nextMonth = mktime($hour, $min, $sec, $month + 1, min($day, date("t", mktime(0,0,0,$month + 1, 1, $year))), $year);
$lastMonth = mktime($hour, $min, $sec, $month - 1, min($day, date("t", mktime(0,0,0,$month - 1, 1, $year))), $year);

$linkToday = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $today) );
$linkSelected = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $selected) );
$linkNextYear = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $nextYear) );
$linkLastYear = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $lastYear) );
$linkNextMonth = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $nextMonth) );
$linkLastMonth = $form->getJsActionCall( new ComponentResolvableFormAction($key, "ts", $lastMonth) );

$colorBorder = "#000000";
$colorHeader = "#ffffc0";
$colorMonth = "#cccccc";
$colorDays = "#ffffc0";
$colorToday = "#ff686b";
$colorSelected = "#A4D9FF";
$colorHilighted = "#f9ce68";
$colorDisabled = "#444444";
$colorCW = "#336633";

$dateFormat = $this->d_time->getDateFormat();
$ts = $this->d_time->getTimestamp();
$tn = $TIME;

$partTableFormat = "cellpadding=1 cellspacing=1";

$html = "<table cellspacing=1 cellpadding=0 bgcolor=$colorBorder>\n";

$html .= "<tr><td bgcolor=$colorHeader><table width=100% $partTableFormat><tr>\n";
$html .= "  <td align=left>".i18n("Selected date").": <a href=\"javascript:$linkSelected\">".date($dateFormat, $selected)."</a></td>\n";
$html .= "  <td align=right>".i18n("Today").": <a href=\"javascript:$linkToday\">".date($dateFormat, $today)."</a></td>\n";
$html .= "</tr></table></td></tr>\n";

$html .= "<tr><td bgcolor=$colorMonth><table width=100% $partTableFormat><tr>\n";
$html .= "  <td align=left width=15%>&nbsp;<a href=\"javascript:$linkLastYear\">&lt;</a>&nbsp;&nbsp;<a href=\"javascript:$linkLastMonth\">&lt;&lt;</a></td>\n";
$html .= "  <td align=center width=70%> <b>".i18n(date("F",$selected))." ".date("Y",$selected)."</b> </td>\n";
$html .= "  <td align=right width=15%><a href=\"javascript:$linkNextMonth\">&gt;&gt;</a>&nbsp;&nbsp;<a href=\"javascript:$linkNextYear\">&gt;</a>&nbsp;</td>\n";
$html .= "</tr></table></td></tr>\n";

$html .= "<tr><td bgcolor=$colorDays><table width=100% $partTableFormat>\n";

$html .= "<tr align=center><td><font color=$colorCW> ".i18n("CW")." </font></td>";
for ($i = 0; $i < 7; $i++) {
$html .= "<td width=25>".$this->d_time->translateDayOfWeek($i, true)."</td>";
}
$html .= "</tr>\n";

$w = date("w",mktime(0,0,0,$month, 1, $year)) - 1;
$firstWeekDay = ($w < 0)?$w + 7:$w;
$lastMonthDays = date("t",$lastMonth);
$monthDays = date("t",$selected);
$col = 0;

for ($i = $lastMonthDays - $w + 1; $i <= $lastMonthDays; $i++) {
if ($col == 0) $html .= "<tr align=center><td><font color=$colorCW>".date("W",mktime(0,0,0,$month - 1, $i, $year))."</font></td>";
$html .= "  <td><font color=$colorDisabled>$i</td>\n";
$col++;
}

for ($i = 1; $i <= $monthDays; $i++) {
if ($col == 0) $html .= "<tr align=center><td><font color=$colorCW>".date("W",mktime(0,0,0,$month, $i, $year))."</font></td>";

$text = $i;
if ($i == date("d",$ts) && $month == date("m",$ts) && $year == date("Y",$ts)) $text = " [ $text ] ";
if ($i == date("d",$tn) && $month == date("m",$tn) && $year == date("Y",$tn)) $text = "<b>$text</b>";

$color = "";
if ($hilight) $color = " bgcolor=$colorHilight";
else if ($i == date("d",$ts) && $month == date("m",$ts) && $year == date("Y",$ts)) $color = " bgcolor=$colorSelected";
else if ($i == date("d",$tn) && $month == date("m",$tn) && $year == date("Y",$tn)) $color = " bgcolor=$colorToday";

$html .= "  <td$color>";
$html .= "<a href=\"javascript:".$form->getJsActionCall( new ComponentResolvableFormAction($key, "select", mktime($hour, $min, $sec, $month, $i, $year) ) )."\">";
$html .= $text."</a></td>\n";

$col++;
if ($col == 7) { $html .= "</tr>\n"; $col = 0; }
}

if ($col > 0) {
for ($i = 1; $i <= 7 - $col; $i++) {
$html .= "  <td><font color=$colorDisabled>$i</td>\n";
}
$html .= "</tr>";
}

$html .= "</tr>";

$html .= "</table></td></tr>";

$html .= "</table>";

return $this->mergeResult( parent::getHTML($form, $fieldPrefix, $doCheck, $checkSeverity, $key), $html );
}

}

?>
