<?php
$mainGUI = &GUIFactory::setMainGUI( "main" );

node_include("load_menu");
load_menu(15214,T_CONTENTREPOSITORIES,T_CONTENTREPOSITORIES);

mysession_var_reg("CR_ID");
unset($CR_ID);

$ASSCORE = "";

//    
//        
//                                      
//                                                 
//                                                        

//                                  
node_class("htmlform3");
node_class("itemlist3");
node_class("itemlistcomponent");
node_class("arraydatasource");
node_class("listcomponent");
node_class("commandaction");
node_class("sqldatasource");
node_class("dateformatter");

unset($ERROR);

class CheckStatusFormatter extends ResultsetFormatter {
var $statusfield;

function CheckStatusFormatter($statusfield) {
$this->statusfield = $statusfield;
}

function format( $row ) {
global $STAG;
switch($row[$this->statusfield]) {
case 0:
$code = "<span style=\"color: red\">".i18n("Error")."</span>";
break;
case 1:
$code = "<span style=\"color: green\">".i18n("Ok")."</span>";
break;
default:
$code = i18n("unchecked");
break;
}

if ($row["checkresult"]) {
return "<a href=\"$STAG&do=15215&cr_id=".$row["id"]."\">$code</a>";
} else {
return $code;
}
}
}

class PermissionsComparator {
var $action;

function PermissionsComparator($action) {
$this->action = $action;
}

function compareTo( $value ) {
global $USER_ID, $T_CONTENT;

$retval = 0;
if ($this->action == "editstructure") {
$retval = !perm($USER_ID, T_CONTENTREPOSITORY, $value, 2);
} else if ($this->action == "assignnodes") {
$retval = !(perm($USER_ID, T_CONTENTREPOSITORY, $value, 2) && perm($USER_ID, $T_CONTENT, 0, 0) && perm($USER_ID, $T_CONTENT, 0, 8));
} else {
$retval = 1;
}

return $retval;
}
}

class DBTypeFormatter extends ResultsetFormatter {
function format( $row ) {
global $CONTENTREPOSITORY_DATABASES;
return $CONTENTREPOSITORY_DATABASES[$row["dbtype"]];
}
}

function cmd_do_editstructure($id) {
global $CR_ID, $REDO;
$CR_ID = $id;
$REDO = 15200;
}

function cmd_do_assignnodes($id) {
global $CR_ID, $REDO;
$CR_ID = $id;
$REDO = 15216;
}

$crList = new HtmlForm3("cr_list");

if ($crList->isNew()) {
$crList->setHeader("ContentRepositories");
$main = new ListComponent();

$ds = new SQLDatasource( 'cr_list_sql', 'id,name,dbtype,url,username,checkdate,checkstatus,checkresult,statusdate', 'contentrepository');//            
 $ds->setPermInfo ( T_CONTENTREPOSITORY, 0);
$ds->setDBHandle( $DB );

$ds->addColumn("name", i18n("Name"), true, true, true);
$ds->addColumn("dbtype", i18n("dbtype"), true, true, true);
$ds->addColumn("url", i18n("url"), true, true, true);
$ds->addColumn("statusdate", i18n("last publish"), true, true, true);
$ds->addColumn("checkdate", i18n("checkdate"), true, true, true);
$ds->addColumn("checkstatus", i18n("checkstatus"), true, true, true);

$ds->addFormatter("checkdate", new DateFormatter("checkdate"));
$ds->addFormatter("checkstatus", new CheckStatusFormatter("checkstatus"));
$ds->addFormatter("statusdate", new DateFormatter("statusdate"));
$ds->addFormatter("dbtype", new DBTypeFormatter());
$ds->makeLink( 'name', 'name', "do=15211", 'list', 'cr_id', 'id' );
//                                                                                   

$ds->addAction( new CommandAction( $ICO_CONTENTREPOSITORY_CHECK, 'check', i18n( 'check'), 'cmd_contentrepository_check' ) );
$ds->addAction( new CommandAction( $ICO_CONTENTREPOSITORY_REPAIR, 'repair', i18n( 'repair'), 'cmd_contentrepository_repair' ) );
$ds->addAction( new CommandAction( $ICO_CONTENTREPOSITORY_COPY, 'copy', i18n('copy'), "cmd_contentrepository_copy") );    
$ds->addAction( new CommandAction( $ICO_DELETE, 'delete', i18n('delete'), "cmd_contentrepository_del") );    

$ds->addSingleAction(new CommandAction(null, "editstructure", i18n("Tagmap"), "cmd_do_editstructure"), "id", new PermissionsComparator("editstructure"));
$ds->addSingleAction(new CommandAction(null, "assignnodes", i18n("Assign Nodes"), "cmd_do_assignnodes"), "id", new PermissionsComparator("assignnodes"));

$list = new ItemList3("cr_list", $ds );

$main->setComponent('crlist', new ItemListComponent( null, $list ) );
$crList->addComponent( 'main', $main );
} else {
//                                                  
 $crlistcomp = & $crList->resolveComponent( 'main.crlist' );
$itemlist3 = & $crlistcomp->getList();
$ds = & $itemlist3->getDatasource();
$ds->setDBHandle( $DB );
}

?>
