<?php
//
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//        //           /       /                                           
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//
//                                                      
//
//                                                                
//           
//

//
//            
//
//                                                               
//                                  
//

require_once(INCLUDE_PATH."/common.php");

class DB_mysql extends DB_common
{
//               

var $connection;
var $phptype, $dbsyntax;
var $prepare_tokens = array();
var $prepare_types = array();
var $num_rows = array();
var $transaction_opcount = 0;
var $autocommit = true;
var $fetchmode = DB_FETCHMODE_ORDERED; /*                    */
var $_db = false;

//    
 //                

/**
     *                      
     *
     *               
     */

function DB_mysql()
{
$this->DB_common();
$this->phptype = 'mysql';
$this->dbsyntax = 'mysql';
$this->features = array(
'prepare' => false,
'pconnect' => true,
'transactions' => true,
'limit' => 'alter'
);
$this->errorcode_map = array(
1004 => DB_ERROR_CANNOT_CREATE,
1005 => DB_ERROR_CANNOT_CREATE,
1006 => DB_ERROR_CANNOT_CREATE,
1007 => DB_ERROR_ALREADY_EXISTS,
1008 => DB_ERROR_CANNOT_DROP,
1046 => DB_ERROR_NODBSELECTED,
1050 => DB_ERROR_ALREADY_EXISTS,
1051 => DB_ERROR_NOSUCHTABLE,
1054 => DB_ERROR_NOSUCHFIELD,
1062 => DB_ERROR_ALREADY_EXISTS,
1064 => DB_ERROR_SYNTAX,
1100 => DB_ERROR_NOT_LOCKED,
1136 => DB_ERROR_VALUE_COUNT_ON_ROW,
1146 => DB_ERROR_NOSUCHTABLE,
1048 => DB_ERROR_CONSTRAINT,
);
}

//    

//              

/**
     *                                                        
     *
     *                                                               
     *                                                            
     *                     
     *               
     *                                                    
     */

function connect($dsninfo, $persistent = false)
{
if (!DB::assertExtension('mysql'))
return $this->raiseError(DB_ERROR_EXTENSION_NOT_FOUND);

$this->dsn = $dsninfo;
if (isset($dsninfo['protocol']) && $dsninfo['protocol'] == 'unix') {
$dbhost = ':' . $dsninfo['socket'];
} else {
$dbhost = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
if (!empty($dsninfo['port'])) {
$dbhost .= ':' . $dsninfo['port'];
}
}
$user = $dsninfo['username'];
$pw = $dsninfo['password'];

$connect_function = $persistent ? 'mysql_pconnect' : 'mysql_connect';

@ini_set('track_errors', true);
if ($dbhost && $user && $pw) {
$conn = @$connect_function($dbhost, $user, $pw);
} elseif ($dbhost && $user) {
$conn = @$connect_function($dbhost, $user);
} elseif ($dbhost) {
$conn = @$connect_function($dbhost);
} else {
$conn = false;
}
@ini_restore('track_errors');
if (empty($conn)) {
if (($err = @mysql_error()) != '') {
return $this->raiseError(DB_ERROR_CONNECT_FAILED, null, null,
null, $err);
} elseif (empty($php_errormsg)) {
return $this->raiseError(DB_ERROR_CONNECT_FAILED);
} else {
return $this->raiseError(DB_ERROR_CONNECT_FAILED, null, null,
null, $php_errormsg);
}
}

if ($dsninfo['database']) {
if (!@mysql_select_db($dsninfo['database'], $conn)) {
switch(mysql_errno($conn)) {
case 1049:
return $this->raiseError(DB_ERROR_NOSUCHDB, null, null,
null, mysql_error($conn));
break;
case 1044:
return $this->raiseError(DB_ERROR_ACCESS_VIOLATION, null, null,
null, mysql_error($conn));
break;
default:
return $this->raiseError(DB_ERROR, null, null,
null, mysql_error($conn));
break;

}
}
//                                                             
 $this->_db = $dsninfo['database'];
}

$this->connection = $conn;
return DB_OK;
}

//    
 //                 

/**
     *                                          
     *
     *               
     *
     *                                                      
     */
function disconnect()
{
$ret = mysql_close($this->connection);
$this->connection = null;
return $ret;
}

//    
 //                  

/**
     *                                                                 
     *            
     *
     *                     
     *
     *               
     *
     *                                                                 
     *                                                            
     *                     
     */
function simpleQuery($query)
{
$ismanip = DB::isManip($query);
$this->last_query = $query;
$query = $this->modifyQuery($query);
if ($this->_db) {
if (!@mysql_select_db($this->_db, $this->connection)) {
return $this->mysqlRaiseError(DB_ERROR_NODBSELECTED);
}
}
if (!$this->autocommit && $ismanip) {
if ($this->transaction_opcount == 0) {
$result = @mysql_query('SET AUTOCOMMIT=0', $this->connection);
$result = @mysql_query('BEGIN', $this->connection);
if (!$result) {
return $this->mysqlRaiseError();
}
}
$this->transaction_opcount++;
}
$result = @mysql_query($query, $this->connection);
if (!$result) {
return $this->mysqlRaiseError();
}
if (is_resource($result)) {
$numrows = $this->numrows($result);
if (is_object($numrows)) {
return $numrows;
}
$this->num_rows[$result] = $numrows;
return $result;
}
return DB_OK;
}

//    
 //                 

/**
     *                                                                    
     *
     *                                     
     *
     *               
     *
     *                                                             
     */
function nextResult($result)
{
return false;
}

//    
 //               

/**
     *                                                            
     *                                       
     *                                                 
     *                                                      
     *
     *                                                  
     */
function fetchRow($result, $fetchmode = DB_FETCHMODE_DEFAULT, $rownum=null)
{
if ($fetchmode == DB_FETCHMODE_DEFAULT) {
$fetchmode = $this->fetchmode;
}
$res = $this->fetchInto ($result, $arr, $fetchmode, $rownum);
if ($res !== DB_OK) {
return $res;
}
return $arr;
}

//    
 //                

/**
     *                                                        
     *
     *                                       
     *                                                                
     *                                                       
     *                                         
     *               
     *
     *                                                    
     */
function fetchInto($result, &$arr, $fetchmode, $rownum=null)
{
if ($rownum !== null) {
if (!@mysql_data_seek($result, $rownum)) {
return null;
}
}
if ($fetchmode & DB_FETCHMODE_ASSOC) {
$arr = @mysql_fetch_array($result, MYSQL_ASSOC);
} else {
$arr = @mysql_fetch_row($result);
}
if (!$arr) {
$errno = @mysql_errno($this->connection);
if (!$errno) {
return NULL;
}
return $this->mysqlRaiseError($errno);
}
return DB_OK;
}

//    
 //                 

/**
     *                                                     
     *
     *                                                                  
     *
     *               
     *
     *                                                          
     */
function freeResult($result)
{
if (is_resource($result)) {
return mysql_free_result($result);
}

$result = (int)$result; //                                   
 if (!isset($this->prepare_tokens[$result])) {
return false;
}

//                                                           
 //                                                

$copy = $this->prepare_types;
unset($copy[$result]);
$this->prepare_types = $copy;
//                                             

$copy = $this->prepare_tokens;
unset($copy[$result]);
$this->prepare_tokens = $copy;
//                                              

return true;
}

//    
 //              

/**
     *                                           
     *
     *                                       
     *
     *               
     *
     *                                                     
     */
function numCols($result)
{
$cols = @mysql_num_fields($result);

if (!$cols) {
return $this->mysqlRaiseError();
}

return $cols;
}

//    
 //              

/**
     *                                        
     *
     *                                       
     *
     *               
     *
     *                                          
     */
function numRows($result)
{
$rows = @mysql_num_rows($result);
if ($rows === null) {
return $this->mysqlRaiseError();
}
return $rows;
}

//    
 //                 

/**
     *       /                         
     */
function autoCommit($onoff = false)
{
//                                                          
 //                      
 $this->autocommit = $onoff ? true : false;
return DB_OK;
}

//    
 //             

/**
     *                                
     */
function commit()
{
if ($this->transaction_opcount > 0) {
if ($this->_db) {
if (!@mysql_select_db($this->_db, $this->connection)) {
return $this->mysqlRaiseError(DB_ERROR_NODBSELECTED);
}
}
$result = @mysql_query('COMMIT', $this->connection);
$result = @mysql_query('SET AUTOCOMMIT=1', $this->connection);
$this->transaction_opcount = 0;
if (!$result) {
return $this->mysqlRaiseError();
}
}
return DB_OK;
}

//    
 //               

/**
     *                                          
     */
function rollback()
{
if ($this->transaction_opcount > 0) {
if ($this->_db) {
if (!@mysql_select_db($this->_db, $this->connection)) {
return $this->mysqlRaiseError(DB_ERROR_NODBSELECTED);
}
}
$result = @mysql_query('ROLLBACK', $this->connection);
$result = @mysql_query('SET AUTOCOMMIT=1', $this->connection);
$this->transaction_opcount = 0;
if (!$result) {
return $this->mysqlRaiseError();
}
}
return DB_OK;
}

//    
 //                   

/**
     *                                                          
     *                                                    
     *
     *                                                  
     */

function affectedRows()
{
if (DB::isManip($this->last_query)) {
$result = @mysql_affected_rows($this->connection);
} else {
$result = 0;
}
return $result;
}

//    
 //                  

/**
     *                                                          
     *                                   
     *
     *               
     *
     *                                    
     */

function errorNative()
{
return mysql_errno($this->connection);
}

//    
 //             

/**
     *                                                        
     *                                                           
     *
     *               
     *
     *                                                 
     *
     *                                                                     
     *                  
     *
     *                                                
     */
function nextId($seq_name, $ondemand = true)
{
$seqname = $this->getSequenceName($seq_name);
do {
$repeat = 0;
$this->pushErrorHandling(PEAR_ERROR_RETURN);
$result = $this->query("UPDATE ${seqname} ".
'SET id=LAST_INSERT_ID(id+1)');
$this->popErrorHandling();
if ($result == DB_OK) {
/**             **/
$id = mysql_insert_id($this->connection);
if ($id != 0) {
return $id;
}
/**                 **/
//                                                                      
 //                         
 $result = $this->getOne("SELECT GET_LOCK('${seqname}_lock',10)");
if (DB::isError($result)) {
return $this->raiseError($result);
}
if ($result == 0) {
//                                                              
 return $this->mysqlRaiseError(DB_ERROR_NOT_LOCKED);
}

//                      
 $result = $this->query("REPLACE INTO ${seqname} VALUES (0)");
if (DB::isError($result)) {
return $this->raiseError($result);
}

//                 
 $result = $this->getOne("SELECT RELEASE_LOCK('${seqname}_lock')");
if (DB::isError($result)) {
return $this->raiseError($result);
}
//                                                         
 return 1;

/**                         **/
} elseif ($ondemand && DB::isError($result) &&
$result->getCode() == DB_ERROR_NOSUCHTABLE)
{
$result = $this->createSequence($seq_name);
//                                                 
 //                                                           
 if (DB::isError($result)) {
return $this->raiseError($result);
} else {
//                                          
 return 1;
}

/**                  **/
} elseif (DB::isError($result) &&
$result->getCode() == DB_ERROR_ALREADY_EXISTS)
{
//                          
 $result = $this->_BCsequence($seqname);
if (DB::isError($result)) {
return $this->raiseError($result);
}
$repeat = 1;
}
} while ($repeat);

return $this->raiseError($result);
}

//    
 //                     

function createSequence($seq_name)
{
$seqname = $this->getSequenceName($seq_name);
$res = $this->query("CREATE TABLE ${seqname} ".
'(id INTEGER UNSIGNED AUTO_INCREMENT NOT NULL,'.
' PRIMARY KEY(id))');
if (DB::isError($res)) {
return $res;
}
//                                                      
 return $this->query("INSERT INTO ${seqname} VALUES(0)");
}

//    
 //                   

function dropSequence($seq_name)
{
$seqname = $this->getSequenceName($seq_name);
return $this->query("DROP TABLE ${seqname}");
}

//    

/**
    *                                                                  
    *                     
    *                                                     
    *                               
    */
function _BCsequence($seqname)
{
//                                                           
 //                                                             
 //                                                          
 $result = $this->getOne("SELECT GET_LOCK('${seqname}_lock',10)");
if (DB::isError($result)) {
return $result;
}
if ($result == 0) {
//                                                      
 //                                 
 return $this->mysqlRaiseError(DB_ERROR_NOT_LOCKED);
}

$highest_id = $this->getOne("SELECT MAX(id) FROM ${seqname}");
if (DB::isError($highest_id)) {
return $highest_id;
}
//                                             
 //                                                     
 //                                                    
 $result = $this->query("DELETE FROM ${seqname} WHERE id <> $highest_id");
if (DB::isError($result)) {
return $result;
}

//                                                  
 //                                                      
 //            
 $result = $this->getOne("SELECT RELEASE_LOCK('${seqname}_lock')");
if (DB::isError($result)) {
return $result;
}
return true;
}

//            
 /**
    *                                                                         
    *            
    *                                       
    *                                                            
    */
function quote($str = null)
{
switch (strtolower(gettype($str))) {
case 'null':
return 'NULL';
case 'integer':
return $str;
case 'string':
default:
return "'".mysql_escape_string($str)."'";
}
}
//    
 //                  

function modifyQuery($query, $subject = null)
{
if ($this->options['optimize'] == 'portability') {
//                                                    
 //                                                           
 if (preg_match('/^\s*DELETE\s+FROM\s+(\S+)\s*$/i', $query)) {
$query = preg_replace('/^\s*DELETE\s+FROM\s+(\S+)\s*$/',
'DELETE FROM \1 WHERE 1=1', $query);
}
}
return $query;
}

//    
 //                       

function modifyLimitQuery($query, $from, $count)
{
return $query . " LIMIT $from, $count";
}

//    
 //                      

function mysqlRaiseError($errno = null)
{
if ($errno === null) {
$errno = $this->errorCode(mysql_errno($this->connection));
}
return $this->raiseError($errno, null, null, null,
@mysql_errno($this->connection) . " ** " .
@mysql_error($this->connection));
}

//    
 //                

function tableInfo($result, $mode = null) {
$count = 0;
$id    = 0;
$res   = array();

/*
         *                                                           
         *
         *                           
         *           
         *                           
         *                           
         *                           
         *                             
         *                            
         *
         *                             
         *           
         *                                            
         *                           
         *                           
         *                           
         *                             
         *                            
         *                                                           
         *                                                                
         *                                                      
         *
         *                                  
         *                                       
         *                                                        
         *                        
         *
         *                                                        
         *                                      *                   
         *                                   
         *
         *                                            
         *                                                       
         *                              *                          
         */

//                                                         
 //                          
 if (is_string($result)) {
$id = @mysql_list_fields($this->dsn['database'],
$result, $this->connection);
if (empty($id)) {
return $this->mysqlRaiseError();
}
} else { //                                           
 $id = $result;
if (empty($id)) {
return $this->mysqlRaiseError();
}
}

$count = @mysql_num_fields($id);

//                                                                    
 if (empty($mode)) {
for ($i=0; $i<$count; $i++) {
$res[$i]['table'] = @mysql_field_table ($id, $i);
$res[$i]['name']  = @mysql_field_name  ($id, $i);
$res[$i]['type']  = @mysql_field_type  ($id, $i);
$res[$i]['len']   = @mysql_field_len   ($id, $i);
$res[$i]['flags'] = @mysql_field_flags ($id, $i);
}
} else { //     
 $res['num_fields']= $count;

for ($i=0; $i<$count; $i++) {
$res[$i]['table'] = @mysql_field_table ($id, $i);
$res[$i]['name']  = @mysql_field_name  ($id, $i);
$res[$i]['type']  = @mysql_field_type  ($id, $i);
$res[$i]['len']   = @mysql_field_len   ($id, $i);
$res[$i]['flags'] = @mysql_field_flags ($id, $i);
if ($mode & DB_TABLEINFO_ORDER) {
$res['order'][$res[$i]['name']] = $i;
}
if ($mode & DB_TABLEINFO_ORDERTABLE) {
$res['ordertable'][$res[$i]['table']][$res[$i]['name']] = $i;
}
}
}

//                                                  
 if (is_string($result)) {
@mysql_free_result($id);
}
return $res;
}

//    
 //                     

/**
    *                                                  
    *                                                           
    *                                    
    */
function getSpecialQuery($type)
{
switch ($type) {
case 'tables':
$sql = "SHOW TABLES";
break;
case 'views':
return DB_ERROR_NOT_CAPABLE;
case 'users':
$sql = "select distinct User from user";
if($this->dsn['database'] != 'mysql') {
$dsn = $this->dsn;
$dsn['database'] = 'mysql';
if (DB::isError($db = DB::connect($dsn))) {
return $db;
}
$sql = $db->getCol($sql);
$db->disconnect();
//                                                    
 if (!@mysql_select_db($this->dsn['database'], $this->connection)) {
return $this->mysqlRaiseError(DB_ERROR_NODBSELECTED);
}
}
return $sql;
break;
case 'databases':
$sql = "SHOW DATABASES";
break;
default:
return null;
}
return $sql;
}

//    

//     /         
 //            
 //        
}

?>
